Package org.jbpm.services.api.query

## Interface QueryResultMapper<T>

- Type Parameters:
    `T` - type of the object this mapper will produce
  All Superinterfaces:
    `Serializable`
  All Known Implementing Classes:
    `ExecutionErrorQueryMapper`, `NamedQueryMapper`, `ProcessInstanceCustomQueryMapper`, `ProcessInstanceQueryMapper`, `ProcessInstanceWithCustomVarsQueryMapper`, `ProcessInstanceWithVarsQueryMapper`, `RawListQueryMapper`, `TaskSummaryQueryMapper`, `UserTaskInstanceQueryMapper`, `UserTaskInstanceWithCustomVarsQueryMapper`, `UserTaskInstanceWithModifVarsQueryMapper`, `UserTaskInstanceWithPotOwnerQueryMapper`, `UserTaskInstanceWithVarsQueryMapper`

      public interface QueryResultMapper<T>
      extends Serializable

  Maps raw data set into object instances.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static String` | `COLUMN_ACTIVATIONTIME` |
    `static String` | `COLUMN_ACTUALOWNER` |
    `static String` | `COLUMN_CORRELATIONKEY` |
    `static String` | `COLUMN_CREATEDBY` |
    `static String` | `COLUMN_CREATEDON` |
    `static String` | `COLUMN_DEPLOYMENTID` |
    `static String` | `COLUMN_DESCRIPTION` |
    `static String` | `COLUMN_DUEDATE` |
    `static String` | `COLUMN_DURATION` |
    `static String` | `COLUMN_END` |
    `static String` | `COLUMN_ERROR` |
    `static String` | `COLUMN_ERROR_ACK` |
    `static String` | `COLUMN_ERROR_ACK_AT` |
    `static String` | `COLUMN_ERROR_ACK_BY` |
    `static String` | `COLUMN_ERROR_ACTIVITY_ID` |
    `static String` | `COLUMN_ERROR_ACTIVITY_NAME` |
    `static String` | `COLUMN_ERROR_DATE` |
    `static String` | `COLUMN_ERROR_DEPLOYMENT_ID` |
    `static String` | `COLUMN_ERROR_ID` |
    `static String` | `COLUMN_ERROR_JOB_ID` |
    `static String` | `COLUMN_ERROR_MSG` |
    `static String` | `COLUMN_ERROR_PROCESS_ID` |
    `static String` | `COLUMN_ERROR_PROCESS_INST_ID` |
    `static String` | `COLUMN_ERROR_TYPE` |
    `static String` | `COLUMN_EXCLUDED_OWNER` |
    `static String` | `COLUMN_EXPIRATIONTIME` |
    `static String` | `COLUMN_EXTERNALID` |
    `static String` | `COLUMN_FORM_NAME` |
    `static String` | `COLUMN_IDENTITY` |
    `static String` | `COLUMN_JOB_BUSINESSKEY` |
    `static String` | `COLUMN_JOB_COMMANDNAME` |
    `static String` | `COLUMN_JOB_ID` |
    `static String` | `COLUMN_JOB_MESSAGE` |
    `static String` | `COLUMN_JOB_STATUS` |
    `static String` | `COLUMN_JOB_TIMESTAMP` |
    `static String` | `COLUMN_LASTMODIFICATION_DATE` |
    `static String` | `COLUMN_LASTMODIFICATION_USER` |
    `static String` | `COLUMN_NAME` |
    `static String` | `COLUMN_ORGANIZATIONAL_ENTITY` |
    `static String` | `COLUMN_OUTCOME` |
    `static String` | `COLUMN_PARENTID` |
    `static String` | `COLUMN_PARENTPROCESSINSTANCEID` |
    `static String` | `COLUMN_POTOWNER` |
    `static String` | `COLUMN_PRIORITY` |
    `static String` | `COLUMN_PROCESS_LASTMODIFICATIONDATE` |
    `static String` | `COLUMN_PROCESSID` |
    `static String` | `COLUMN_PROCESSINSTANCEDESCRIPTION` |
    `static String` | `COLUMN_PROCESSINSTANCEID` |
    `static String` | `COLUMN_PROCESSNAME` |
    `static String` | `COLUMN_PROCESSTYPE` |
    `static String` | `COLUMN_PROCESSVERSION` |
    `static String` | `COLUMN_SLA_COMPLIANCE` |
    `static String` | `COLUMN_SLA_DUE_DATE` |
    `static String` | `COLUMN_START` |
    `static String` | `COLUMN_STATUS` |
    `static String` | `COLUMN_SUBJECT` |
    `static String` | `COLUMN_TASK_PROCESSID` |
    `static String` | `COLUMN_TASK_PROCESSINSTANCEID` |
    `static String` | `COLUMN_TASK_SLA_COMPLIANCE` |
    `static String` | `COLUMN_TASK_SLA_DUE_DATE` |
    `static String` | `COLUMN_TASK_STATUS` |
    `static String` | `COLUMN_TASK_TYPE` |
    `static String` | `COLUMN_TASK_VAR_NAME` |
    `static String` | `COLUMN_TASK_VAR_TYPE` |
    `static String` | `COLUMN_TASK_VAR_VALUE` |
    `static String` | `COLUMN_TASKID` |
    `static String` | `COLUMN_VAR_NAME` |
    `static String` | `COLUMN_VAR_VALUE` |
    `static String` | `COLUMN_WORKITEMID` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `QueryResultMapper<T>` | `forColumnMapping​(Map<String,​String> columnMapping)` | Returns new instance of the mapper for given column mapping
    `String` | `getName()` | Returns unique name of this query result mapper implementation.
    `Class<?>` | `getType()` | Returns type of the data produced by this mapper.
    `T` | `map​(Object result)` | Based on raw data set returns mapped/transformed data.

- - ### Field Detail

    - #### COLUMN_PROCESSINSTANCEID

          static final String COLUMN_PROCESSINSTANCEID

      See Also:
        Constant Field Values

    - #### COLUMN_PROCESSID

          static final String COLUMN_PROCESSID

      See Also:
        Constant Field Values

    - #### COLUMN_START

          static final String COLUMN_START

      See Also:
        Constant Field Values

    - #### COLUMN_END

          static final String COLUMN_END

      See Also:
        Constant Field Values

    - #### COLUMN_STATUS

          static final String COLUMN_STATUS

      See Also:
        Constant Field Values

    - #### COLUMN_PARENTPROCESSINSTANCEID

          static final String COLUMN_PARENTPROCESSINSTANCEID

      See Also:
        Constant Field Values

    - #### COLUMN_OUTCOME

          static final String COLUMN_OUTCOME

      See Also:
        Constant Field Values

    - #### COLUMN_DURATION

          static final String COLUMN_DURATION

      See Also:
        Constant Field Values

    - #### COLUMN_IDENTITY

          static final String COLUMN_IDENTITY

      See Also:
        Constant Field Values

    - #### COLUMN_PROCESSVERSION

          static final String COLUMN_PROCESSVERSION

      See Also:
        Constant Field Values

    - #### COLUMN_PROCESSNAME

          static final String COLUMN_PROCESSNAME

      See Also:
        Constant Field Values

    - #### COLUMN_PROCESSTYPE

          static final String COLUMN_PROCESSTYPE

      See Also:
        Constant Field Values

    - #### COLUMN_CORRELATIONKEY

          static final String COLUMN_CORRELATIONKEY

      See Also:
        Constant Field Values

    - #### COLUMN_EXTERNALID

          static final String COLUMN_EXTERNALID

      See Also:
        Constant Field Values

    - #### COLUMN_PROCESSINSTANCEDESCRIPTION

          static final String COLUMN_PROCESSINSTANCEDESCRIPTION

      See Also:
        Constant Field Values

    - #### COLUMN_SLA_DUE_DATE

          static final String COLUMN_SLA_DUE_DATE

      See Also:
        Constant Field Values

    - #### COLUMN_SLA_COMPLIANCE

          static final String COLUMN_SLA_COMPLIANCE

      See Also:
        Constant Field Values

    - #### COLUMN_PROCESS_LASTMODIFICATIONDATE

          static final String COLUMN_PROCESS_LASTMODIFICATIONDATE

      See Also:
        Constant Field Values

    - #### COLUMN_VAR_NAME

          static final String COLUMN_VAR_NAME

      See Also:
        Constant Field Values

    - #### COLUMN_VAR_VALUE

          static final String COLUMN_VAR_VALUE

      See Also:
        Constant Field Values

    - #### COLUMN_ACTIVATIONTIME

          static final String COLUMN_ACTIVATIONTIME

      See Also:
        Constant Field Values

    - #### COLUMN_ACTUALOWNER

          static final String COLUMN_ACTUALOWNER

      See Also:
        Constant Field Values

    - #### COLUMN_CREATEDBY

          static final String COLUMN_CREATEDBY

      See Also:
        Constant Field Values

    - #### COLUMN_CREATEDON

          static final String COLUMN_CREATEDON

      See Also:
        Constant Field Values

    - #### COLUMN_DEPLOYMENTID

          static final String COLUMN_DEPLOYMENTID

      See Also:
        Constant Field Values

    - #### COLUMN_DESCRIPTION

          static final String COLUMN_DESCRIPTION

      See Also:
        Constant Field Values

    - #### COLUMN_DUEDATE

          static final String COLUMN_DUEDATE

      See Also:
        Constant Field Values

    - #### COLUMN_NAME

          static final String COLUMN_NAME

      See Also:
        Constant Field Values

    - #### COLUMN_SUBJECT

          static final String COLUMN_SUBJECT

      See Also:
        Constant Field Values

    - #### COLUMN_PARENTID

          static final String COLUMN_PARENTID

      See Also:
        Constant Field Values

    - #### COLUMN_PRIORITY

          static final String COLUMN_PRIORITY

      See Also:
        Constant Field Values

    - #### COLUMN_TASK_PROCESSID

          static final String COLUMN_TASK_PROCESSID

      See Also:
        Constant Field Values

    - #### COLUMN_TASK_PROCESSINSTANCEID

          static final String COLUMN_TASK_PROCESSINSTANCEID

      See Also:
        Constant Field Values

    - #### COLUMN_TASK_STATUS

          static final String COLUMN_TASK_STATUS

      See Also:
        Constant Field Values

    - #### COLUMN_TASKID

          static final String COLUMN_TASKID

      See Also:
        Constant Field Values

    - #### COLUMN_TASK_SLA_DUE_DATE

          static final String COLUMN_TASK_SLA_DUE_DATE

      See Also:
        Constant Field Values

    - #### COLUMN_TASK_SLA_COMPLIANCE

          static final String COLUMN_TASK_SLA_COMPLIANCE

      See Also:
        Constant Field Values

    - #### COLUMN_WORKITEMID

          static final String COLUMN_WORKITEMID

      See Also:
        Constant Field Values

    - #### COLUMN_ORGANIZATIONAL_ENTITY

          static final String COLUMN_ORGANIZATIONAL_ENTITY

      See Also:
        Constant Field Values

    - #### COLUMN_EXCLUDED_OWNER

          static final String COLUMN_EXCLUDED_OWNER

      See Also:
        Constant Field Values

    - #### COLUMN_EXPIRATIONTIME

          static final String COLUMN_EXPIRATIONTIME

      See Also:
        Constant Field Values

    - #### COLUMN_POTOWNER

          static final String COLUMN_POTOWNER

      See Also:
        Constant Field Values

    - #### COLUMN_TASK_TYPE

          static final String COLUMN_TASK_TYPE

      See Also:
        Constant Field Values

    - #### COLUMN_FORM_NAME

          static final String COLUMN_FORM_NAME

      See Also:
        Constant Field Values

    - #### COLUMN_LASTMODIFICATION_USER

          static final String COLUMN_LASTMODIFICATION_USER

      See Also:
        Constant Field Values

    - #### COLUMN_LASTMODIFICATION_DATE

          static final String COLUMN_LASTMODIFICATION_DATE

      See Also:
        Constant Field Values

    - #### COLUMN_TASK_VAR_NAME

          static final String COLUMN_TASK_VAR_NAME

      See Also:
        Constant Field Values

    - #### COLUMN_TASK_VAR_VALUE

          static final String COLUMN_TASK_VAR_VALUE

      See Also:
        Constant Field Values

    - #### COLUMN_TASK_VAR_TYPE

          static final String COLUMN_TASK_VAR_TYPE

      See Also:
        Constant Field Values

    - #### COLUMN_JOB_ID

          static final String COLUMN_JOB_ID

      See Also:
        Constant Field Values

    - #### COLUMN_JOB_TIMESTAMP

          static final String COLUMN_JOB_TIMESTAMP

      See Also:
        Constant Field Values

    - #### COLUMN_JOB_STATUS

          static final String COLUMN_JOB_STATUS

      See Also:
        Constant Field Values

    - #### COLUMN_JOB_COMMANDNAME

          static final String COLUMN_JOB_COMMANDNAME

      See Also:
        Constant Field Values

    - #### COLUMN_JOB_MESSAGE

          static final String COLUMN_JOB_MESSAGE

      See Also:
        Constant Field Values

    - #### COLUMN_JOB_BUSINESSKEY

          static final String COLUMN_JOB_BUSINESSKEY

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR_ID

          static final String COLUMN_ERROR_ID

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR_TYPE

          static final String COLUMN_ERROR_TYPE

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR_DEPLOYMENT_ID

          static final String COLUMN_ERROR_DEPLOYMENT_ID

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR_PROCESS_INST_ID

          static final String COLUMN_ERROR_PROCESS_INST_ID

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR_PROCESS_ID

          static final String COLUMN_ERROR_PROCESS_ID

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR_ACTIVITY_ID

          static final String COLUMN_ERROR_ACTIVITY_ID

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR_ACTIVITY_NAME

          static final String COLUMN_ERROR_ACTIVITY_NAME

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR_JOB_ID

          static final String COLUMN_ERROR_JOB_ID

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR_MSG

          static final String COLUMN_ERROR_MSG

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR

          static final String COLUMN_ERROR

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR_ACK

          static final String COLUMN_ERROR_ACK

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR_ACK_BY

          static final String COLUMN_ERROR_ACK_BY

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR_ACK_AT

          static final String COLUMN_ERROR_ACK_AT

      See Also:
        Constant Field Values

    - #### COLUMN_ERROR_DATE

          static final String COLUMN_ERROR_DATE

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### map

          T map​(Object result)

      Based on raw data set returns mapped/transformed data. Usually it will get set of raw data and return list (or collection in general) of custom object like ProcessInstance or UserTaskInstance.
      Parameters:
        `result` - raw data set in custom format
      Returns:
        mapped result of raw data set

    - #### getName

          String getName()

      Returns unique name of this query result mapper implementation.
      Returns:
        name

    - #### getType

          Class<?> getType()

      Returns type of the data produced by this mapper. If the type is collection then the returned type should be type of the elements in collection e.g.:
      `List<ProcessInstanceDesc> returned type should be ProcessInstanceDesc.class`
      Returns:
        type

    - #### forColumnMapping

          QueryResultMapper<T> forColumnMapping​(Map<String,​String> columnMapping)

      Returns new instance of the mapper for given column mapping
      Parameters:
        `columnMapping` - provides column mapping (name to type) that can be shipped to mapper for improved transformation - can be null (accepted types: string, long, integer, date, double)
      Returns:
        new instance of the mapper configured with column mapping